###
 #
 # FreeWLAN Addons - http://www.freewlan.info
 #
 # This Script is based on the original La Fonera Firmware version 0.7.1r2
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
 # as published by the Free Software Foundation; either version 2
 # of the License, or (at your option) any later version.
 #
 # This program is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 # GNU General Public License for more details.
 #
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 # MA  02110-1301, USA
 #
 # http://www.gnu.org/copyleft/gpl.html
 #
###

function textinput(name, value) {
	return "<input type=\"text\" name=\"" name "\" value=\"" value "\" />"
}

function hidden(name, value) {
	return "<input type=\"hidden\" name=\"" name "\" value=\"" value "\" />"
}

function button(name, caption) {
	return "<input type=\"submit\" name=\"" name "\" value=\"@TR<<" caption ">>\" />"
}

function sel_option(name, caption, default, sel) {
	if (default == name) sel = " selected=\"selected\""
	else sel = ""
	return "<option value=\"" name "\"" sel ">@TR<<" caption ">></option>"
}

function close_field() {
	if (field_open == 1) print "</td></tr></table><div style=\"clear:both; height: 5pt;\">&nbsp;</div>"
	field_open = 0
}

BEGIN {
	FS="|"
}

# trim leading whitespaces
{
	gsub(/^[ \t]+/,"",$1)
}

$1 ~ /^onchange/ {
	onchange = $2
}

($1 != "") && ($1 !~ /^option/) && (select_open == 1) {
	select_open = 0
	printf "</select>"
}

$1 ~ /^infotext/ {
	close_field()
	print "<p >@TR<<" $2 ">></p>"
}


#
# Table issues
#

$1 ~/^infotable/ {
	close_field()
	print "<p class=\"tableText\">@TR<<" $2 ">></p>"
}

#
# $2: the summary of the table.
#

$1 ~ /^start_table/ {
	close_field()
	print "<TABLE border=\"" $2  "\" cellspacing=\"" $3 "\" cellpadding=\"" $4 "\" summary=\"" $5 "\">"
}

$1 ~ /^start_border_table/ {
	close_field()
	print " <tr><td bgcolor=\"FADCBF\">"
	print "  <table border=\"0\" cellspacing=\"0\" cellpadding=\"1\">"
	print "  <tr><td>"
	print "      <TABLE border=\"0\" cellspacing=\"0\" cellpadding=\"0\">"
}

$1 ~ /^end_border_table/ {
	close_field()
	print " 	</TABLE> "
	print "  </td></tr> "
	print "  </table> "
	print " </td> </tr> " 
}

$1 ~ /^end_table/ {
	close_field()
	print "</TABLE>"
}

#
# $2: The title of the table
#
$1 ~ /^table_caption/ {
	close_field()
	print "<tr><td ALIGN=\"CENTER\" class=\"tableText\"><EM>" $2 "</EM></TD></tr>"
}

#
# Begins a new row to the table
#
$1 ~ /^add_row/ {
	close_field()
	print "<TR>"
}


$1 ~ /^end_row/ {
	close_field()
	print "</TR>"
}
#
# Add a cell to the row:
#	$2: height of the row
#	$3: width of the row
#	$4: text of the row
$1 ~ /^add_title_cell/ {
	close_field()
	print "<TD bgcolor=\"FADCBF\" class=\"tableText Bold\">@TR<<" $2 ">></TD>"
}

$1 ~ /^add_normal_cell/ {
	close_field()
	print "<TD bgcolor=\"ffffff\" class=\"tableText\">" $2 "</TD>" 
}

$1 ~ /^add_label_cell/ {
        close_field()
        print "<TD valign=\"middle\" class=\"tableText\">" $2 "</TD>"
}

$1 ~ /^add_pass_cell/ {
	close_field
	print "<TD class=\"tableText\">"
	print "<input id=\"" $2 "\" valign=\"middle\" type=\"password\" name=\"" $2 "\" class=\"" $3 "\" value=\"" $4 "\"/>" $5
	print "</TD>"
}

$1 ~ /^start_select_cell/ {
	opts = ""
        if (onchange != "") opts = opts " onChange=\"" onchange "()\""
	print "<TD class=\"tableText\">"
        print "<select id=\"" $2 "\" valign=\"middle\" name=\"" $2 "\" class=\"" $4 "\"" opts ">"
        select_id = $2
        select_open = 1
	select_default = $3
}

$1 ~ /^end_select_cell/ {
	close_field()
	print " </select></td>"
}

$1 ~ /^add_input_cell/ {
	print "<TD class=\"tableText\">"
	print "<input id=\"" $2 "\" valign=\"middle\" type=\"text\" name=\"" $2 "\" value=\"" $3 "\" class=\"" $4 "\"/>" $5
	print "</TD>"
	
}

$1 ~ /^add_button_cell/ {
	close_field()
	print "<TD class=\"tableText\">"
        print "<label>&nbsp;</label><input type=\"submit\" name=\"" $2 "\" value=\"" $3  "\" class=\"plain_button_orange\" />"
	print "</TD>"
	
}

$1 ~ /^add_check_cell/ {
	opts=""
        if (onchange != "") opts = opts " onClick=\"" onchange "()\" onChange=\"" onchange "()\""
	print "<TD class=\"tableText\">"$3
        print "<input id=\"" $2  "\" type=\"checkbox\" name=\"" $2 "\"  " opts " class=\"" $4 "\"/>"
	print "</TD>"
}

# Draw a line
$1 ~ /^draw_line/ {
	close_field()
	print "<tr><td colspan=\"2\"><hr /></td></tr>"
}

$1 ~ /^start_div/ {
	close_field()
	print "<div id=\"" $2 "\">"
}

$1 ~ /^end_div/ {
	close_field()
	print "</div>"
}

$1 ~ /^field/ {
	close_field()
	print "<label>@TR<<" $2 ">></label><table><tr><td>"
	field_open=1
}
$1 ~ /^checkbox/ {
	if ($3==$4) opts="checked=\"checked\" "
	else opts=""
	if (onchange != "") opts = opts " onClick=\"" onchange "()\" onChange=\"" onchange "()\""
	print "<input id=\"" $2 "_" $4 "\" type=\"checkbox\" name=\"" $2 "\" value=\"" $4 "\" " opts " />"
}
$1 ~ /^radio/ {
	if ($3==$4) opts="checked=\"checked\" "
	else opts=""
	if (onchange != "") opts = opts " onClick=\"" onchange "()\" onChange=\"" onchange "()\""
	print "<input id=\"" $2 "_" $4 "\" type=\"radio\" name=\"" $2 "\" value=\"" $4 "\" " opts " />"
}
$1 ~ /^select/ {
	opts = ""
	if (onchange != "") opts = opts " onChange=\"" onchange "()\""
	print "<select id=\"" $2 "\" name=\"" $2 "\"" opts ">"
	select_id = $2
	select_open = 1
	select_default = $3
}
($1 ~ /^option/) && (select_open == 1) {
	if ($2 == select_default) option_selected=" selected=\"selected\""
	else option_selected=""
	if ($3 != "") option_title = $3
	else option_title = $2
	print "<option id=\"" select_id "_" $2 "\"" option_selected " value=\"" $2 "\">" option_title "&nbsp;&nbsp;</option>"
}

$1 ~ /^caption/ { print "<b>" $2 "</b>" }
$1 ~ /^string/ { print $2 }
$1 ~ /^text/ { print "<input id=\"" $2 "\" type=\"text\" name=\"" $2 "\" value=\"" $3 "\" />" $4 }
$1 ~ /^password/ { print "<input id=\"" $2 "\" type=\"password\" name=\"" $2 "\" value=\"" $3 "\" />" $4 }
$1 ~ /^submit/ {
	close_field()
	print "<label>&nbsp;</label><input type=\"submit\" name=\"" $2 "\" value=\"" $3  "\" class=\"plain_button_orange\" />"
}

$1 ~ /^help$/ {
	close_field()
	print "<script type=\"text/javascript\">"
	print "function help()"
	print "{"
	print "helpwindow= window.open (\"/cgi-bin/webif/help/" $2 ".sh\", \"helpwindow\", \"location=1,status=1,scrollbars=1,width=400,height=400\");"
	print "helpwindow.moveTo(0,0);"
	print "}"
	print "</script>"
	print "<div id=\"help\">"
	print "<a href=\"javascript:help()\"><img src=\"/images/help.png\" alt=\"image_help\" border=\"0\" /> @TR<<Help>></a>"
	print "</div>"
}

$1 ~ /^help_topic/ {
	print "<h1>" $2 "</h1>"
}

$1 ~ /^help_explanation/ {
	print "<p style=\"font-size: 10pt;\">" $2 "</p>"
}

$1 ~ /^add_au_select_branch/ {
	close_field();
	print("<td class=\"tableText\">");
	print("<select id=\"" $2 "\" valign=\"middle\" name=\"" $2 "\" class=\"" $4 "\">"); 
	print("<option value=\"stable\""); if( $3 == "stable" ) print(" selected=\"selcted\""); print(">stable</option>");
	# We prolly don't have a connection, so print the selected one if it's not stable
	if ( $5 == "" && $3 != "stable" ) {
		print("<option value=\"" $3 "\" selected=\"selected\">" $3 "</option>");
	}
	for(i = 5; $(i) != ""; i++) {
		print("<option value=\"" $(i) "\""); if ( $(i) == $3 ) printf(" selected=\"selected\""); printf(">" $(i) "</option>");
	}
	print("</select></td>");
}

($1 ~ /^checkbox/) || ($1 ~ /^radio/) {
	print $5
}

END {
	close_field()
}


