#!/usr/bin/webif-page
<?

###
 #
 # FreeWLAN Addons - http://www.freewlan.info
 #
 # This Script is based on the original La Fonera Firmware version 0.7.1r2
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
 # as published by the Free Software Foundation; either version 2
 # of the License, or (at your option) any later version.
 #
 # This program is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 # GNU General Public License for more details.
 #
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 # MA  02110-1301, USA
 #
 # http://www.gnu.org/copyleft/gpl.html
 #
###

. /usr/lib/webif/webif.sh

sel_port_fw=1
. /usr/lib/webif/advanced.sh

validate <<EOF
string|FORM_submit|@TR<<Submit>>|max=10|$FORM_submit
EOF

if [ "$?" != "0" ]
then
	FORM_submit=""
fi

NOTICE="@TR<<TabInfoOk#Forwarded Ports>>"
Repeated="0"

if [ ! -e /tmp/frules ]
then
	touch /tmp/frules
fi

if [ "$FORM_submit" != "" ]
then
	validate <<EOF
add_remove|FORM_srule|@TR<<Select>>|required|$FORM_srule
EOF
	if [ "$?" != "0" ]
	then
		NOTICE="@TR<<InvVal#You have inserted some invalid values>>"
	else
		if [ "$FORM_srule" == "add" ]
		then
			validate <<EOF
port|FORM_origp|@TR<<Public Port>>|required|$FORM_origp
port|FORM_origpr|@TR<<Public Port Range>>||$FORM_origpr
ip|FORM_destip|@TR<<Destination IP>>|required|$FORM_destip
port|FORM_destp|@TR<<Private Port>>|required|$FORM_destp
port|FORM_destpr|@TR<<Private Port Range>>||$FORM_destpr
tcp_udp|FORM_sproto|@TR<<Protocol>>||$FORM_sproto
EOF
			if [ "$?" != "0" ]
			then
				NOTICE="@TR<<InvVal#You have entered some invalid values.>>"
			else
				cat /tmp/frules | grep "^open_port \$1 $FORM_origp" > /tmp/repeated
				for x in `cat /tmp/repeated`
				do
					echo $x >> /tmp/repeated
					if [ "$FORM_sproto" == "both" ]
					then
						Repeated="1"
					elif [ "$x" == "$FORM_sproto" ]
					then
						Repeated="1"
					fi
				done

				rm /tmp/repeated

				if [ "$Repeated" == "1" ]
				then
					NOTICE="@TR<<RepPort#This port is currently forwarded check another one or delete it first>>"
				else
					if [ "$FORM_origpr" != "" ]
					then
						if [ $FORM_origpr -lt $FORM_origp ]
						then
							DONTOPEN="1"
							NOTICE="@TR<<BiggerPur#The second public port must be bigger than the first one>>"
						else
							FORM_origp=`echo "$FORM_origp":"$FORM_origpr"`
						fi
					fi
					if [ "$FORM_destpr" != "" ]
					then
						if [ $FORM_destpr -lt $FORM_destp ]
						then
							DONTOPEN="1"
							NOTICE="@TR<<BiggerPr#The second private port must be bigger than the first one>>"
						else
							FORM_destp=`echo "$FORM_destp"-"$FORM_destpr"`
						fi
					fi
					if [ "$DONTOPEN" != "1" ]
					then
						if [ "$FORM_sproto" == "both" ]
						then
							echo "open_port \$1" "$FORM_origp" "$FORM_destip" "$FORM_destp" "udp" >> /etc/config/openports
							echo "open_port \$1" "$FORM_origp" "$FORM_destip" "$FORM_destp" "tcp" >> /etc/config/openports
							/etc/init.d/S45firewall
						else
							echo "open_port \$1" "$FORM_origp" "$FORM_destip" "$FORM_destp" "$FORM_sproto" >> /etc/config/openports
							/etc/init.d/S45firewall
						fi
					fi
				fi
			fi
		else
			validate <<EOF
int|FORM_sruledel|@TR<<Select rule>>|min=0|$FORM_sruledel
EOF
			if [ "$?" != "0" ]
			then
				NOTICE="@TR<<InvVal#You have entered some invalid values.>>"
			else
				DELLINE=`head -n $FORM_sruledel /tmp/frules | tail -n 1`
				cat /etc/config/openports | grep -v "$DELLINE" > /etc/config/openports
				/etc/init.d/S45firewall
			fi
		fi
	fi
fi

FORM_origp=""
FORM_origpr=""
FORM_destip=""
FORM_destp=""
FORM_destpr=""
FORM_sproto=""

ncell="add_normal_cell|"
optrull="option"
id=1

echo "" > /tmp/pftable
echo "" > /tmp/optrules

cat /etc/config/openports | grep -v "^#" | grep open_port > /tmp/frules

max=`cat /tmp/frules | sed -n '$='`
if [ "$max" == "" ]
then
	max=0
fi

for i in `seq $max`
do
	x=`head -n $i /tmp/frules | tail -n 1`
	oport=`echo $x | cut -d" " -f3`
	dip=`echo $x | cut -d" " -f4`
	dport=`echo $x | cut -d" " -f5`
	proto=`echo $x | cut -d" " -f6`
    if [ "$proto" = "" ]
    then
	proto="tcp/udp"
    fi
    # New rows of the tabprivate
	echo "add_row" >> /tmp/pftable
	echo "  $ncell$i" >> /tmp/pftable
	echo "  $ncell$oport" >>/tmp/pftable
	echo "  $ncell$dip" >> /tmp/pftable
	echo "  $ncell$dport" >> /tmp/pftable
	echo "  $ncell$proto" >> /tmp/pftable
	echo "end_row" >> /tmp/pftable
    # New option for delete rules
    echo "option|$i|$i" >> /tmp/optrules
done

TABLE="$(cat /tmp/pftable)"
OPTRULES="$(cat /tmp/optrules)"

header "PF_Title#Port Forwarding"

cat <<EOF
    <script type="text/javascript">
    <!--
    function modechange()
    {
	selector = document.getElementById("srule");
	v = selector.options[selector.selectedIndex].value;
	layeradd = document.getElementById("add_rule_stuff");
	layerrem = document.getElementById("rem_rule_stuff");
	layeradd.style.display="none";
	layerrem.style.display="none";
	layeradd.style.visibility="hidden";
	layerrem.style.visibility="hidden";

	if (v == "add")
	{
		layeradd.style.display="block";
		layeradd.style.visibility="visible";
	}
	else
	{
		layerrem.style.display="block";
		layerrem.style.visibility="visible";
	}
    }
    function showRange1()
    {
	selector = document.getElementById("checkR1");
	selinput = document.getElementById("origpr");
	v =  selector.checked;

	if (v==true)
	{
		selinput.style.display="block";
		selinput.value="";
	}
	else
	{
		selinput.style.display="none"
		selinput.value=""
	}
    }

    function showRange2()
    {
	selector = document.getElementById("checkR2");
	selinput = document.getElementById("destpr");
	v = selector.checked

	if (v==true)
	{
		selinput.style.display="block";
		selinput.value="";
	}
	else
	{
		selinput.style.display="none"
		selinput.value=""
	}
    }
    -->
    </script>
EOF

display_form <<EOF

	infotable|Port_Fw#Here you can forward the ports that you need to be open.

	start_table|0|0|0
		table_caption|$NOTICE
		start_border_table
			add_row
				add_title_cell|Id
				add_title_cell|Public Port
				add_title_cell|Destination IP
				add_title_cell|Private Port
				add_title_cell|Protocol
			end_row
		$TABLE
		end_border_table
	end_table

	infotext

	start_table|0|10|5
		onchange|modechange
		add_row
			add_label_cell|@TR<<Select>>
			start_select_cell|srule|$FORM_srule|tableTextSelect
				option|add|@TR<<Add>>
				option|remove|@TR<<Delete>>
			end_select_cell
		end_row
	end_table

	start_div|fill_rule_stuff
    end_div

    start_div|add_rule_stuff
	start_table|0|10|5
		add_row
			add_label_cell|@TR<<IPdest#Destination IP>>
			add_input_cell|destip|$FORM_destip|inputIP
		end_row
	end_table

	start_table|0|10|5
		add_row
			add_label_cell|@TR<<OPort#Public Port>>
			add_input_cell|origp|$FORM_origp|inputPort
			add_label_cell|-
			add_input_cell|origpr|$FORM_origpr|inputPort
			onchange|showRange1
			add_check_cell|checkR1|@TR<<range>>&nbsp;&nbsp;|tableCheckBox
		end_row
		add_row
			add_label_cell|@TR<<DPort#Private Port>>
			add_input_cell|destp|$FORM_destp|inputPort
			add_label_cell|-
			add_input_cell|destpr|$FORM_destpr|inputPort
				onchange|showRange2
			add_check_cell|checkR2|@TR<<range>>&nbsp;&nbsp;|tableCheckBox
		end_row
	end_table

	start_table|0|10|5
		add_row
			onchange|onchange
			add_label_cell|@TR<<Protocol>>
			start_select_cell|sproto|$FORM_sproto|tableTextSelect
				option|both|@TR<<TCP and UDP>>
				option|tcp|TCP
				option|udp|UDP
			end_select_cell
		end_row
		add_row
			add_label_cell
			add_button_cell|submit|@TR<<Add>>
		end_row
	end_table
    end_div

    start_div|rem_rule_stuff
	start_table|0|10|5
		add_row
			add_label_cell|@TR<<Select rule>>
			start_select_cell|sruledel|$FORM_sruledel|tableTextSelect
				$OPTRULES
			end_select_cell
		end_row
		add_row
			add_button_cell|submit|@TR<<Delete>>
		end_row
	end_table
    end_div
EOF

cat <<EOF
    <script type="text/javascript">
    <!--
	modechange();
	showRange1();
	showRange2();
    -->
    </script>
EOF

footer ?>