#!/usr/bin/webif-page
<?

###
 #
 # FreeWLAN Addons - http://www.freewlan.info
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
 # as published by the Free Software Foundation; either version 2
 # of the License, or (at your option) any later version.
 #
 # This program is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 # GNU General Public License for more details.
 #
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 # MA  02110-1301, USA
 #
 # http://www.gnu.org/copyleft/gpl.html
 #
###

. /usr/lib/webif/webif.sh

validate <<EOF
string|FORM_submit|@TR<<Submit>>|max=10|$FORM_submit
EOF

if [ "$?" != "0" ]
then
	FORM_submit=""
fi

config_load autoupdate
config_get url method url
if empty "$FORM_submit"; then
	get_default url method url
	get_default auto method auto
	get_default branch method branch
else
	validate <<EOF
		bool|FORM_auto|@TR<<Addon autoupdate>>|required|$FORM_auto
		string|FORM_branch|@TR<<Chosen branch>>|required|$FORM_branch
#		url|FROM_url|@TR<<Update server URL>>|required|$FORM_url
EOF
	equal "$?" 0 && {
#		save_setting autoupdate method url "$FORM_url"
		save_setting autoupdate method auto "$FORM_auto"
		save_setting autoupdate method branch "$FORM_branch"
		commit_settings
		SAVED=1
	}
fi

sel_autoupdate=1
. /usr/lib/webif/advanced.sh

header "Addon Autoupdate"

if ! empty "$FORM_update"; then
	echo "@TR<<Updating...>><br /><pre>"
	/bin/autoupdate.sh manual
	echo "</pre>@TR<<finished.>>"
else

	branches=$(wget -O - $url/branches 2> /dev/null)

	display_form <<EOF
		infotable|Advanced_autoupdate#Here you can configure Addon autoupdate behaviour.

		start_table|0|10|5
			add_row
				add_label_cell|@TR<<Update addons automatically>>
				start_select_cell|auto|$FORM_auto|tableTextSelect
					option|1|@TR<<Enabled>>
					option|0|@TR<<Disabled>>
				end_select_cell
			end_row
			add_row
				add_label_cell|@TR<<Update server URL>>
				add_label_cell|$FORM_url
			end_row
			add_row
				add_label_cell|@TR<<Choose branch>>
				add_au_select_branch|branch|$FORM_branch|tableTextSelect|$branches
			end_row
		end_table
		start_table|0|10|5
			add_row
				add_button_cell|submit|@TR<<Submit>>|tableTextButton
			end_row
		end_table
		help|autoupdate
EOF

	instversion="$(cat /etc/addon_version)"
	echo "@TR<<Installed version>>: $instversion<br />"

	#if ping -c 1 "$(echo $url|awk -F/ '{print $3}')" > /dev/null 2> /dev/null; then
	if [ "$branches" != "" ]; then
		if wget -q -O /dev/null $url/$FORM_branch/$instversion/install.sh 2> /dev/null; then
			echo "@TR<<Update available>><br />";
			display_form <<EOF
				start_table|0|10|5
					add_row
						add_button_cell|update|@TR<<Update now!>>|tableTextButton
					end_row
				end_table
EOF
		else
			echo "@TR<<No update available>>";
		fi
	else
		echo "<br />@TR<<No connection to the update server!>>"
	fi
fi

footer ?>
